"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Keycap = exports.KeyCombo = exports.KeySequence = void 0;
const react_1 = __importStar(require("react"));
const classnames_1 = __importDefault(require("classnames"));
const key_module_scss_1 = __importDefault(require("./key.module.scss"));
const key_characters_1 = require("./key-characters");
/** renders a sequence of keys, e.g. `ctrl+K then ctrl+d` */
function KeySequence(_a) {
    var { children, className } = _a, rest = __rest(_a, ["children", "className"]);
    if (!children)
        return null;
    const content = react_1.useMemo(() => {
        const split = children
            .split(' ')
            .map((x) => x.trim())
            .filter((x) => !!x);
        const mapped = split.map((combo, idx) => react_1.default.createElement(KeyCombo, { key: idx }, combo));
        const withThens = insertBetween(mapped, (idx) => react_1.default.createElement(Then, { key: `then-sep_${idx}` }));
        return withThens;
    }, [children]);
    return (react_1.default.createElement("div", Object.assign({}, rest, { className: classnames_1.default(key_module_scss_1.default.keySequence, className) }), content));
}
exports.KeySequence = KeySequence;
/** renders a key combination */
function KeyCombo(_a) {
    var { children, className } = _a, rest = __rest(_a, ["children", "className"]);
    if (!children)
        return null;
    const split = children.split('+').map((x) => x.trim());
    return (react_1.default.createElement("div", Object.assign({}, rest, { className: classnames_1.default(className, key_module_scss_1.default.keyCombo) }), split.map((x, idx) => (react_1.default.createElement(Keycap, { key: idx }, x)))));
}
exports.KeyCombo = KeyCombo;
/** renders children as a physical key */
function Keycap(_a) {
    var { className, children } = _a, rest = __rest(_a, ["className", "children"]);
    const prettyKey = children in key_characters_1.keySymbols ? key_characters_1.keySymbols[children] : children;
    return (react_1.default.createElement("kbd", Object.assign({}, rest, { className: classnames_1.default(className, key_module_scss_1.default.keycap) }), prettyKey));
}
exports.Keycap = Keycap;
function insertBetween(arr, toInsert) {
    const res = [];
    arr.forEach((item, idx) => {
        res.push(item);
        res.push(toInsert(idx));
    });
    res.pop(); // remove trailing item
    return res;
}
function Then() {
    return react_1.default.createElement("span", { className: key_module_scss_1.default.thenSep }, "then");
}
//# sourceMappingURL=keycap.js.map